<?php

declare(strict_types=1);

namespace App\Admin;

use App\Entity\Token;
use App\LDAP\Database;
use Carbon\Carbon;
use Sonata\AdminBundle\Admin\AbstractAdmin;
use Sonata\AdminBundle\Datagrid\DatagridMapper;
use Sonata\AdminBundle\Datagrid\ListMapper;
use Sonata\AdminBundle\Form\FormMapper;
use Sonata\AdminBundle\Form\Type\ModelType;
use Sonata\AdminBundle\Route\RouteCollection;
use Sonata\AdminBundle\Show\ShowMapper;
use Sonata\Form\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Security\Core\Security;

final class TokenAdmin extends AbstractAdmin
{
    /**
     * @var Database
     */
    private $database;

    /**
     * @var Security
     */
    private $security;

    /**
     * @required
     * @param Database $database
     * @return TokenAdmin
     */
    public function setDatabase(Database $database): TokenAdmin
    {
        $this->database = $database;
        return $this;
    }

    /**
     * @required
     * @param Security $security
     * @return TokenAdmin
     */
    public function setSecurity(Security $security): TokenAdmin
    {
        $this->security = $security;
        return $this;
    }

    /**
     * @todo Move this to another admin
     * @param RouteCollection $collection
     */
    protected function configureRoutes(RouteCollection $collection)
    {
        $collection
            ->add('list_users', 'list_users')
            ->add('list_subsystems', 'list_subsystems');
    }

    protected function configureDatagridFilters(DatagridMapper $datagridMapper): void
    {
        $datagridMapper
            ->add('id')
            ->add('code')
            ->add('createdBy')
            ->add('type')
            ->add('expiry')
            ->add('active')
            ->add('data')
            ;
    }

    protected function configureListFields(ListMapper $listMapper): void
    {
        $listMapper
            ->add('id')
            ->add('code')
            ->add('createdBy')
            ->add('type')
            ->add('expiry')
            ->add('active')
            ->add('data')
            ->add('_action', null, [
                'actions' => [
                    'show' => [],
                    'edit' => [],
                    'delete' => [],
                ],
            ]);
    }

    protected function configureFormFields(FormMapper $formMapper): void
    {
        $bo = [
            'required' => false
        ];
        $formMapper
            ->with('User Data', [
                'description' => 'Add some data for this user. The user will NOT be able to change these. Feel free to leave them empty, or fill some of them with the correct values.'
            ])
            ->add('data.firstName', TextType::class, $bo)
            ->add('data.lastName', TextType::class, $bo)
            ->add('data.email', TextType::class, $bo)
            ->add('data.phone', TextType::class, $bo)
            ->add('data.subsystem', ChoiceType::class, $bo + [
                'choices' => array_flip(iterator_to_array($this->database->getSubsystems()))
                ])
            ->end()
        ;
    }

    protected function configureShowFields(ShowMapper $showMapper): void
    {
        $showMapper
            ->add('id')
            ->add('code')
            ->add('createdBy')
            ->add('type')
            ->add('expiry')
            ->add('active')
            ->add('data')
            ;
    }

    public function preValidate($object)
    {
        parent::preValidate($object); // TODO: Change the autogenerated stub
    }

    public function preUpdate($object)
    {
        /** @var Token $object */
        $object->setCreatedBy($this->security->getUser()->getCn());
        $object->setData(clone ($object->getData())); // Must clone the object to update (https://stackoverflow.com/a/5808795/717524)
        $object->renew();
    }




}
